Type: Package
Package: directadjusting
Title: Directly Adjusted Estimates
Version: 0.7.0
Authors@R: 
    person("Joonas", "Miettinen", , "joonas.miettinen@cancer.fi", role = c("cre", "aut"),
           comment = c(ORCID = "0000-0001-8624-6754"))
Description: Compute estimates and confidence intervals of weighted
    averages quickly and easily. Weighted averages are computed using
    data.table for speed. Confidence intervals are approximated using the
    delta method with either using known formulae or via algorithmic or
    numerical derivation.
License: MIT + file LICENSE
URL: https://github.com/FinnishCancerRegistry/directadjusting
BugReports: https://github.com/FinnishCancerRegistry/directadjusting/issues
Depends: R (>= 2.10)
Imports: data.table, stats
Config/roxygen2/version: 8.0.0
Encoding: UTF-8
Language: en-GB
NeedsCompilation: no
Packaged: 2026-07-14 09:04:46 UTC; joonas.miettinen
Author: Joonas Miettinen [cre, aut] (ORCID:
    <https://orcid.org/0000-0001-8624-6754>)
Maintainer: Joonas Miettinen <joonas.miettinen@cancer.fi>
Repository: CRAN
Date/Publication: 2026-07-14 09:50:02 UTC
Built: R 4.5.2; ; 2026-07-14 13:23:33 UTC; unix

Type: Package
Package: directadjusting
Title: Directly Adjusted Estimates
Version: 0.6.1
Authors@R: 
    person("Joonas", "Miettinen", , "joonas.miettinen@cancer.fi", role = c("cre", "aut"),
           comment = c(ORCID = "0000-0001-8624-6754"))
Description: Compute estimates and confidence intervals of weighted
    averages quickly and easily. Weighted averages are computed using
    data.table for speed. Confidence intervals are approximated using the
    delta method with either using known formulae or via algorithmic or
    numerical integration.
License: MIT + file LICENSE
URL: https://github.com/FinnishCancerRegistry/directadjusting/
BugReports: https://github.com/FinnishCancerRegistry/directadjusting/issues
Depends: R (>= 2.10)
Imports: data.table, stats
Encoding: UTF-8
Language: en-GB
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-02-02 09:01:43 UTC; joonas.miettinen
Author: Joonas Miettinen [cre, aut] (ORCID:
    <https://orcid.org/0000-0001-8624-6754>)
Maintainer: Joonas Miettinen <joonas.miettinen@cancer.fi>
Repository: CRAN
Date/Publication: 2026-02-04 19:30:02 UTC
Built: R 4.6.0; ; 2026-04-26 16:20:19 UTC; unix

<!-- generated by R package codedoc; do not modify! -->

# Package `directadjusting`


Compute estimates and confidence intervals of weighted averages quickly and easily. Weighted averages are computed using data.table for speed. Confidence intervals are approximated using the delta method with either using known formulae or via algorithmic or numerical integration.

<!-- badges: start -->
[![R-CMD-check](https://github.com/FinnishCancerRegistry/directadjusting/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/FinnishCancerRegistry/directadjusting/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

# Recommended installation

```r
devtools::install_github(
  "FinnishCancerRegistry/directadjusting@release"
)
```

# Example
```r
# suppose we have poisson rates that we want to adjust for by age group.
# they are stratified by sex.
set.seed(1337)
offsets <- rnorm(8, mean = 1000, sd = 100)
baseline <- 100
sex_hrs <- rep(1:2, each = 4)
age_group_hrs <- rep(c(0.75, 0.90, 1.10, 1.25), times = 2)
counts <- rpois(8, baseline * sex_hrs * age_group_hrs)

# raw estimates
my_stats <- data.table::data.table(
  sex = rep(1:2, each = 4),
  ag = rep(1:4, times = 2),
  e = counts / offsets
)
my_stats[, "v" := my_stats[["e"]] / offsets]
print(my_stats)
#      sex    ag          e            v
#    <int> <int>      <num>        <num>
# 1:     1     1 0.08928141 8.759527e-05
# 2:     1     2 0.10054601 1.175523e-04
# 3:     1     3 0.11987410 1.238776e-04
# 4:     1     4 0.09722692 8.365551e-05
# 5:     2     1 0.18043221 1.937844e-04
# 6:     2     2 0.14781448 1.227479e-04
# 7:     2     3 0.21747515 1.987203e-04
# 8:     2     4 0.21519746 1.781152e-04

# adjusted by age group
my_adj_stats <- directadjusting::directly_adjusted_estimates(
  stats_dt = my_stats,
  stat_col_nms = "e",
  var_col_nms = "v",
  conf_lvls = 0.95,
  conf_methods = "log",
  stratum_col_nms = "sex",
  adjust_col_nms = "ag",
  weights = c(200, 300, 400, 100)
)

print(my_adj_stats)
# Key: <sex>
#      sex         e            v       e_lo      e_hi
#    <int>     <num>        <num>      <num>     <num>
# 1:     1 0.1056924 3.474049e-05 0.09474912 0.1178996
# 2:     2 0.1889406 5.237509e-05 0.17527556 0.2036710
```

<!-- generated by R package codedoc; do not modify! -->

# Package `directadjusting`


Compute estimates and confidence intervals of weighted averages quickly and easily. Weighted averages are computed using data.table for speed. Confidence intervals are approximated using the delta method with either using known formulae or via algorithmic or numerical derivation.

<!-- badges: start -->
[![R-CMD-check](https://github.com/FinnishCancerRegistry/directadjusting/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/FinnishCancerRegistry/directadjusting/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

# Recommended installation

You can install this R package from CRAN.

```r
install.packages("directadjusting")
```

Alternatively this installs the latest release.

```r
devtools::install_github(
  "FinnishCancerRegistry/directadjusting@release"
)
```

# Example
```r
# suppose we have poisson rates that we want to adjust for by age group.
# they are stratified by sex.
set.seed(1337)
offsets <- rnorm(8, mean = 1000, sd = 100)
baseline <- 100
sex_hrs <- rep(1:2, each = 4)
age_group_hrs <- rep(c(0.75, 0.90, 1.10, 1.25), times = 2)
counts <- rpois(8, baseline * sex_hrs * age_group_hrs)

# raw estimates
my_stats <- data.table::data.table(
  sex = rep(1:2, each = 4),
  ag = rep(1:4, times = 2),
  e = counts / offsets
)
my_stats[, "v" := my_stats[["e"]] / offsets]
print(my_stats)
#      sex    ag          e            v
#    <int> <int>      <num>        <num>
# 1:     1     1 0.08928141 8.759527e-05
# 2:     1     2 0.10054601 1.175523e-04
# 3:     1     3 0.11987410 1.238776e-04
# 4:     1     4 0.09722692 8.365551e-05
# 5:     2     1 0.18043221 1.937844e-04
# 6:     2     2 0.14781448 1.227479e-04
# 7:     2     3 0.21747515 1.987203e-04
# 8:     2     4 0.21519746 1.781152e-04

# adjusted by age group
my_adj_stats <- directadjusting::directly_adjusted_estimates(
  stats_dt = my_stats,
  stat_col_nms = "e",
  var_col_nms = "v",
  conf_lvls = 0.95,
  conf_methods = "log",
  stratum_col_nms = "sex",
  adjust_col_nms = "ag",
  weights = c(200, 300, 400, 100)
)

print(my_adj_stats)
# Key: <sex>
#      sex         e            v       e_lo      e_hi
#    <int>     <num>        <num>      <num>     <num>
# 1:     1 0.1056924 3.474049e-05 0.09474912 0.1178996
# 2:     2 0.1889406 5.237509e-05 0.17527556 0.2036710
```

#' @title Directly Adjusted Estimates
#' @description Compute direct adjusted estimates from a table of statistics.
#' @param stats_dt `[data.frame]` (no default)
#'
#' a `data.frame` containing estimates and variance estimates of statistics
#' @param stat_col_nms `[character]` (no default)
#'
#' names of columns in `stats_dt` containing estimates (statistics);
#' `NA` statistics values cause also `NA` confidence intervals
#' @param var_col_nms `[character]` (default `NULL`)
#'
#' - if `NULL`, no confidence intervals can (will) be computed
#' - if `character` vector, names of columns in `stats_dt` containing variance
#'   estimates of the statistics specified in `stat_col_nms` with one-to-one
#'   correspondence; `NA` elements in `var_col_nms` cause no confidence
#'   intervals to computed for those statistics;
#'   `NA` variance estimates in `stats_dt` cause `NA` confidence intervals;
#'   negative values cause an error; `Inf` values cause `c(-Inf, Inf)`
#'   intervals with confidence interval method `"identity"`, etc.
#' @param conf_lvls `[numeric]` (default `0.95`)
#'
#' confidence levels for confidence intervals; you may specify each statistic
#' (see `stat_col_nms`) its own level by supplying a vector of values;
#' values other than between `(0, 1)` cause an error
#' @param conf_methods `[character, list]` (default `"identity"`)
#'
#' Method(s) to compute confidence intervals. Either one method for all stats
#' (`stat_col_nms`) or otherwise this must be of length
#' (`length(stat_col_nms)`). Each element is passed to
#' `[delta_method_confidence_intervals]` separately.
#'
#' Can also be `"none"`: This causes no confidence intervals to be calculated
#' for the respective `stat_col_nms` element(s).
#' @param stratum_col_nms `[NULL, character]` (default `NULL`)
#'
#' names of columns in `stats_dt` by which statistics are stratified (and they
#' should be stratified by these columns after direct adjusting)
#' @param adjust_col_nms `[NULL, character]` (default `NULL`)
#'
#' Names of columns in `stats_dt` by which statistics are currently stratified
#' and by which the statistics should be adjusted (e.g. `"agegroup"`).
#'
#' - `NULL`: If `weights` is a `data.table`, use its stratifying columns. Else
#'   no adjusting is performed.
#' - `character`: Adjust by these columns.
#' @template weights_arg
#' @examples
#'
#' # directadjusting::directly_adjusted_estimates
#' library("data.table")
#' set.seed(1337)
#'
#' offsets <- rnorm(8, mean = 1000, sd = 100)
#' baseline <- 100
#' hrs_by_sex <- rep(1:2, each = 4)
#' hrs_by_ag <- rep(c(0.75, 0.90, 1.10, 1.25), times = 2)
#' counts <- rpois(8, baseline * hrs_by_sex * hrs_by_ag)
#'
#' # raw estimates
#' my_stats <- data.table::data.table(
#'   sex = rep(1:2, each = 4),
#'   ag = rep(1:4, times = 2),
#'   e = counts / offsets,
#'   v = counts / (offsets**2)
#' )
#'
#' # adjusted by age group
#' my_adj_stats <- directly_adjusted_estimates(
#'   stats_dt = my_stats,
#'   stat_col_nms = "e",
#'   var_col_nms = "v",
#'   conf_lvls = 0.95,
#'   conf_methods = "log",
#'   stratum_col_nms = "sex",
#'   adjust_col_nms = "ag",
#'   weights = c(200, 300, 400, 100)
#' )
#'
#' # adjusted by smaller age groups, stratified by larger age groups
#' my_stats[, "ag2" := c(1, 1, 2, 2, 1, 1, 2, 2)]
#' my_adj_stats <- directly_adjusted_estimates(
#'   stats_dt = my_stats,
#'   stat_col_nms = "e",
#'   var_col_nms = "v",
#'   conf_lvls = 0.95,
#'   conf_methods = "log",
#'   stratum_col_nms = c("sex", "ag2"),
#'   adjust_col_nms = "ag",
#'   weights = c(200, 300, 400, 100)
#' )
#'
#' # with no adjusting columns defined you get the same table as input
#' # but with confidence intervals. this for the sake of
#' # convenience for programming cases where sometimes you want to adjust,
#' # sometimes not.
#' stats_dt_2 <- data.table::data.table(
#'   sex = 0:1,
#'   e = 0.0,
#'   v = 0.1
#' )
#' dt_2 <- directadjusting::directly_adjusted_estimates(
#'   stats_dt = stats_dt_2,
#'   stat_col_nms = "e",
#'   var_col_nms = "v",
#'   conf_lvls = 0.95,
#'   conf_methods = "identity",
#'   stratum_col_nms = "sex"
#' )
#' stopifnot(
#'   dt_2[["e"]] == stats_dt_2[["e"]],
#'   dt_2[["v"]] == stats_dt_2[["v"]],
#'   dt_2[["sex"]] == stats_dt_2[["sex"]]
#' )
#'
#' # sometimes when adjusting rates or counts, there can be strata where the
#' # statistic is zero. these should be included in your statistics dataset
#' # if you still want the weighted average be influenced by the zero.
#' # otherwise you will get the wrong result. sometimes when naively tabulating
#' # a dataset with e.g. dt[, .N, keyby = "stratum"] one does not get a result
#' # row for a stratum that does not appear in the dataset even if we know that
#' # the stratum exists, for instance only the age groups 1-17 are present in
#' # the dataset.
#' stats_dt_3 <- data.table::data.table(
#'   age_group = 1:18,
#'   count = 17:0,
#'   var = 17:0
#' )
#'
#' # this goes as intended
#' dt_3 <- directadjusting::directly_adjusted_estimates(
#'   stats_dt = stats_dt_3,
#'   stat_col_nms = "count",
#'   var_col_nms = "var",
#'   stratum_col_nms = NULL,
#'   adjust_col_nms = "age_group",
#'   weights = data.table::data.table(
#'     age_group = 1:18,
#'     weight = 18:1
#'   )
#' )
#'
#' # this does not
#' dt_4 <- directadjusting::directly_adjusted_estimates(
#'   stats_dt = stats_dt_3[1:17, ],
#'   stat_col_nms = "count",
#'   var_col_nms = "var",
#'   stratum_col_nms = NULL,
#'   adjust_col_nms = "age_group",
#'   weights = data.table::data.table(
#'     age_group = 1:18,
#'     weight = 18:1
#'   )
#' )
#'
#' # the weighted average that included the zero is smaller
#' stopifnot(
#'   dt_3[["count"]] < dt_4[["count"]]
#' )
#'
#' # NAs are allowed and produce in turn NAs silently.
#' stats_dt_5 <- data.table::data.table(
#'   age_group = 1:18,
#'   count = c(NA, 16:0),
#'   var = c(NA, 16:0)
#' )
#' dt_5 <- directadjusting::directly_adjusted_estimates(
#'   stats_dt = stats_dt_5,
#'   stat_col_nms = "count",
#'   var_col_nms = "var",
#'   adjust_col_nms = "age_group",
#'   weights = data.table::data.table(
#'     age_group = 1:18,
#'     weight = 18:1
#'   )
#' )
#' stopifnot(
#'   is.na(dt_5)
#' )
#'
#' stats_dt_6 <- data.table::data.table(
#'   age_group = 1:4,
#'   survival = c(0.20, 0.40, 0.60, 0.80),
#'   survival_var = 0.05^2
#' )
#' # you can use conf_methods to pass whatever to
#' # `delta_method_confidence_intervals`.
#' dt_6 <- directadjusting::directly_adjusted_estimates(
#'   stats_dt = stats_dt_6,
#'   stat_col_nms = "survival",
#'   var_col_nms = "survival_var",
#'   adjust_col_nms = "age_group",
#'   weights = data.table::data.table(
#'     age_group = 1:4,
#'     weight = 1:4
#'   ),
#'   conf_methods = list(
#'     list(
#'       g = quote(stats::qnorm(theta)),
#'       g_inv = quote(stats::pnorm(g))
#'     )
#'   )
#' )
#'
#' # the wame weights data.table can contain more than one weight column
#' dt_7 <- directadjusting::directly_adjusted_estimates(
#'   stats_dt = stats_dt_6,
#'   stat_col_nms = "survival",
#'   var_col_nms = "survival_var",
#'   adjust_col_nms = "age_group",
#'   weights = data.table::data.table(
#'     age_group = 1:4,
#'     weight_1 = 1:4,
#'     weight2 = 4:1
#'   )
#' )
#' stopifnot(
#'   c("survival_1", "survival2") %in% names(dt_7)
#' )
#'
#' # ... and multiple statistics columns as well
#' data.table::set(
#'   x = stats_dt_6,
#'   j = c("risk", "risk_var"),
#'   value = list(
#'     1 - stats_dt_6[["survival"]],
#'     stats_dt_6[["survival_var"]]
#'   )
#' )
#' dt_8 <- directadjusting::directly_adjusted_estimates(
#'   stats_dt = stats_dt_6,
#'   stat_col_nms = c("survival", "risk"),
#'   var_col_nms = c("survival_var", "risk_var"),
#'   adjust_col_nms = "age_group",
#'   weights = data.table::data.table(
#'     age_group = 1:4,
#'     weight_1 = 1:4,
#'     weight2 = 4:1
#'   )
#' )
#' stopifnot(
#'   c("survival_1", "survival2", "risk_1", "risk2") %in% names(dt_8)
#' )
#'
#' @eval codedoc::pkg_doc_fun("directadjusting::directly_adjusted_estimates")
directly_adjusted_estimates <- function(
  stats_dt,
  stat_col_nms,
  var_col_nms,
  stratum_col_nms = NULL,
  adjust_col_nms = NULL,
  conf_lvls = 0.95,
  conf_methods = "identity",
  weights = NULL
) {
  # @codedoc_comment_block news("directadjusting::direct_adjusted_estimates", "2026-01-22", "0.5.0")
  # `directadjusting::direct_adjusted_estimates` option `conf_methods = "boot"`
  # removed. Only delta method confidence intervals now possible. Making use of
  # the delta method is now more flexible and accepts e.g.
  # `list("log", list(g = quote(qnorm(theta)), g_inv = quote(pnorm(g))))`.
  # @codedoc_comment_block news("directadjusting::direct_adjusted_estimates", "2026-01-22", "0.5.0")
  # assertions -----------------------------------------------------------------
  stopifnot(
    is.data.frame(stats_dt),
    stat_col_nms %in% names(stats_dt),
    is.null(stratum_col_nms) || all(stratum_col_nms %in% names(stats_dt)),
    length(var_col_nms) %in% c(0L, length(stat_col_nms)),
    var_col_nms %in% c(names(stats_dt), NA),

    data.table::between(conf_lvls, lower = 0.0, upper = 1.0, incbounds = FALSE),
    length(conf_lvls) %in% c(1L, length(stat_col_nms)),

    length(conf_methods) %in% c(1L, length(stat_col_nms)),
    inherits(conf_methods, c("character", "list"))
  )
  if (!is.null(var_col_nms)) {
    lapply(setdiff(var_col_nms, NA_character_), function(var_col_nm) {
      eval(substitute(
        stopifnot(
          stats_dt[[VCN]] >= 0 | is.na(stats_dt[[VCN]])
        ),
        list(VCN = var_col_nm)
      ))
    })
  } else {
    var_col_nms <- rep(NA_character_, length(stat_col_nms))
  }
  # @codedoc_comment_block news("directadjusting::direct_adjusted_estimates", "2024-12-12", "0.4.0")
  # `directadjusting::direct_adjusted_estimates` now correctly uses
  # the same `conf_lvls` and `conf_methods` for all statistics when their
  # length is one.
  # @codedoc_comment_block news("directadjusting::direct_adjusted_estimates", "2024-12-12", "0.4.0")
  if (length(conf_lvls) == 1) {
    conf_lvls <- rep(conf_lvls, length(stat_col_nms))
  }
  lapply(seq_along(conf_methods), function(i) {
    if (!is.character(conf_methods[[i]])) {
      return(NULL)
    }
    eval(substitute(
      stopifnot(
        conf_methods[i] %in% ALLOWED
      ),
      list(ALLOWED = allowed_conf_method_strings__())
    ))
  })
  if (length(conf_methods) == 1) {
    conf_methods <- rep(conf_methods, length(stat_col_nms))
  }

  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  # `directadjusting::directly_adjusted_estimates` computes weighted
  # averages and their confidence intervals. Performs the following steps:
  #
  # - Makes a new `data.table` with data from `stats_dt` without copying any
  #   column data to avoid modifying `stats_dt` itself.
  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  work_dt <- local({
    keep_col_nms <- setdiff(
      c(stratum_col_nms, adjust_col_nms, stat_col_nms, var_col_nms),
      NA_character_
    )
    work_dt <- data.table::setDT(as.list(stats_dt)[keep_col_nms])
    work_dt[]
  })
  tmp_stratum_col_nm <- NULL
  if (length(stratum_col_nms) == 0L) {
    tmp_stratum_col_nm <- tmp_nms(
      prefixes = "tmp_stratum_col_",
      avoid = names(work_dt)
    )
    stratum_col_nms <- tmp_stratum_col_nm
    data.table::set(work_dt, j = tmp_stratum_col_nm, value = TRUE)
  }

  # prepare data for adjusted estimates and CIs --------------------------------
  if (is.null(adjust_col_nms) && is.data.frame(weights)) {
    # @codedoc_comment_block news("directadjusting::directly_adjusted_estimates", "2026-07-10", "0.7.0")
    # `directadjusting::directly_adjusted_estimates` argument `adjust_col_nms` is
    # now automatically
    # determined based on `weights` if `weights` is a `data.frame` /
    # `data.table`.
    # @codedoc_comment_block news("directadjusting::directly_adjusted_estimates", "2026-07-10", "0.7.0")
    adjust_col_nms <- names(weights)[!grepl("^weight", names(weights))]
  }
  if (length(adjust_col_nms) == 0) {
    # @codedoc_comment_block news("directadjusting::direct_adjusted_estimates", "2025-11-25", "0.5.0")
    # `directadjusting::direct_adjusted_estimates` now allows for the sake of
    # convenience to be called with no `adjust_col_nms` defined. This results
    # in no adjusting.
    # @codedoc_comment_block news("directadjusting::direct_adjusted_estimates", "2025-11-25", "0.5.0")
    adjust_col_nms <- tmp_nms(
      prefixes = "tmp_adjust_stratum_",
      avoid = names(work_dt)
    )
    data.table::set(
      x = work_dt,
      j = adjust_col_nms,
      value = TRUE
    )
    weights_dt <- data.table::data.table(
      x = TRUE,
      weight = 1.0
    )
    data.table::setnames(weights_dt, "x", adjust_col_nms)
  } else {
    # @codedoc_comment_block directadjusting::directly_adjusted_estimates
    # - Handle argument `weights` in order to produce a `data.table` of weights
    #   if it wasn't one already.
    # @codedoc_comment_block directadjusting::directly_adjusted_estimates
    weights_dt <- weights_arg_to_weights_dt(
      weights = weights,
      stats_dt = work_dt,
      adjust_col_nms = adjust_col_nms
    )
  }

  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  # - Insert the weights into `stats_dt`.
  # @codedoc_insert_comment_block directadjusting:::add_weight_columns__
  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  add_weight_columns__(
    stats_dt = work_dt,
    stratum_col_nms = stratum_col_nms,
    weights_dt = weights_dt,
    adjust_col_nms = adjust_col_nms
  )
  tmp_weight_col_nms <- attr(work_dt, "tmp_weight_col_nms")

  # prep output ----------------------------------------------------------------
  out <- work_dt[
    i = !duplicated(work_dt, by = stratum_col_nms),
    j = .SD,
    .SDcols = stratum_col_nms
  ]

  # delta method confidence intervals ------------------------------------------
  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  # - Compute weighted averages of `stat_col_nms` and `var_col_nms`
  #   (the latter with squared weights because they are variances)
  #   over `adjust_col_nms`. This results in a `data.table` without column(s)
  #   `adjust_col_nms`.
  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  meta_dt <- lapply(seq_along(stat_col_nms), function(i) {
    # @codedoc_comment_block news("directadjusting::directly_adjusted_estimates", "2026-07-13", "0.7.0")
    # `directadjusting::directly_adjusted_estimates` can now handle `weights`
    # `data.table` with more than one column containing weights, e.g.
    # `weight_europe`, `weight_world`.
    # @codedoc_comment_block news("directadjusting::directly_adjusted_estimates", "2026-07-13", "0.7.0")
    suffix_set <- names(tmp_weight_col_nms)
    meta_dt <- lapply(seq_along(suffix_set), function(j) {
      tmp_weight_col_nm_ij <- tmp_weight_col_nms[j]
      stat_col_nms_ij <- paste0(stat_col_nms[i], suffix_set[j])
      var_col_nms_ij <- paste0(var_col_nms[i], suffix_set[j])
      data.table::set(
        x = work_dt,
        j = stat_col_nms_ij,
        value = stats_dt[[stat_col_nms[i]]] * work_dt[[tmp_weight_col_nm_ij]]
      )
      data.table::set(
        x = work_dt,
        j = var_col_nms_ij,
        value = stats_dt[[var_col_nms[i]]] *
          (work_dt[[tmp_weight_col_nm_ij]]^2)
      )
      data.table::data.table(
        stat_col_nm = stat_col_nms[i],
        stat_col_nm_w = stat_col_nms_ij,
        var_col_nm = var_col_nms[i],
        var_col_nm_w = var_col_nms_ij
      )[]
    })
    meta_dt <- data.table::rbindlist(meta_dt)
    return(meta_dt[])
  })
  meta_dt <- data.table::rbindlist(meta_dt)
  local({
    value_col_nms <- c(meta_dt[["stat_col_nm_w"]], meta_dt[["var_col_nm_w"]])
    adjusted_stats_dt <- work_dt[
      #' @importFrom data.table .SD
      j = lapply(.SD, sum),
      .SDcols = value_col_nms,
      keyby = eval(stratum_col_nms)
    ]
    data.table::set(
      x = out,
      j = value_col_nms,
      value = as.list(adjusted_stats_dt)[value_col_nms]
    )
  })
  data.table::set(
    x = meta_dt,
    j = c("conf_method", "conf_lvl"),
    value = list(
      as.list(rep(conf_methods, each = length(tmp_weight_col_nms))),
      rep(conf_lvls, each = length(tmp_weight_col_nms))
    )
  )
  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  # - For each statistic:
  #   + If the corresponding `conf_methods` element is `"none"`, skip confidence
  #     intervals computation.
  #   + Otherwise call `[delta_method_confidence_intervals]`.
  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  lapply(seq_len(nrow(meta_dt)), function(i) {
    if (
      is.character(meta_dt[["conf_method"]][[i]]) &&
        meta_dt[["conf_method"]][[i]] == "none"
    ) {
      return(NULL)
    }
    ci_dt <- delta_method_confidence_intervals(
      statistics = out[[meta_dt[["stat_col_nm_w"]][[i]]]],
      variances = out[[meta_dt[["var_col_nm_w"]][[i]]]],
      conf_lvl = meta_dt[["conf_lvl"]][[i]],
      conf_method = meta_dt[["conf_method"]][[i]]
    )

    ci_col_nms <- paste0(meta_dt[["stat_col_nm_w"]][[i]], c("_lo", "_hi"))
    data.table::set(
      x = out,
      j = ci_col_nms,
      value = as.list(ci_dt)[c("ci_lo", "ci_hi")]
    )
    data.table::set(
      x = meta_dt,
      i = i,
      j = c("ci_lo_col_nm_w", "ci_hi_col_nm_w"),
      value = as.list(ci_col_nms)
    )
    return(NULL)
  })

  # final touches --------------------------------------------------------------
  ordered_stat_col_nms <- unlist(
    lapply(seq_len(nrow(meta_dt)), function(i) {
      unlist(meta_dt[
        i = i,
        j = .SD,
        .SDcols = c(
          "stat_col_nm_w",
          "var_col_nm_w",
          "ci_lo_col_nm_w",
          "ci_hi_col_nm_w"
        )
      ])
    }),
    use.names = FALSE
  )
  data.table::setcolorder(out, c(stratum_col_nms, ordered_stat_col_nms))
  data.table::setkeyv(out, stratum_col_nms)
  if (identical(stratum_col_nms, tmp_stratum_col_nm)) {
    data.table::set(out, j = tmp_stratum_col_nm, value = NULL)
    stratum_col_nms <- NULL
  }
  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  # - Set attribute `directly_adjusted_estimates_meta`. It is a list
  #   containing:
  #   + `call`: The call to `directadjusting::directly_adjusted_estimates`.
  #   + `stat_col_nms`: The argument as given by the user.
  #   + `var_col_nms`: The argument as given by the user.
  #   + `stratum_col_nms`: The argument as given by the user.
  #   + `adjust_col_nms`: The argument as given by the user.
  #   + `conf_lvls`: The argument, but always of length `length(stat_col_nms)`.
  #   + `conf_methods`: The argument, but always of length
  #     `length(stat_col_nms)`.
  #   + `meta_dt`: Contains columns
  #     * `stat_col_nm`: Elements of argument `stat_col_nms`.
  #     * `stat_col_nm_w`: Corresponding name of column containing weighted
  #       statistics. These columns names are in the output of
  #       `directadjusting::directly_adjusted_estimates`.
  #     * `var_col_nm`: Elements of argument `var_col_nms`.
  #     * `var_col_nm_w`: Like `stat_col_nm_w` but for variance column names.
  #     * `conf_method`: Correspoding `conf_methods` elements.
  #     * `conf_lvl`: Correspoding `conf_lvls` elements.
  #     * `ci_lo_col_nm_w`: Name of confidence interval lower bound of the
  #        weighted statistic.
  #     * `ci_hi_col_nm_w`: Name of confidence interval upper bound of the
  #        weighted statistic.
  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  call <- match.call()
  data.table::setattr(
    out,
    "directly_adjusted_estimates_meta",
    mget(c(
      "call",
      "stat_col_nms",
      "var_col_nms",
      "stratum_col_nms",
      "adjust_col_nms",
      "conf_lvls",
      "conf_methods",
      "meta_dt"
    ))
  )

  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  # - Return a `data.table`. Returned columns are those given via
  #   `stratum_col_nms`, `stat_col_nms`, and `var_col_nms` and additional
  #   confidence interval columns. If `weights` was a
  #   `data.table`, the names of the stats, variances, and confidence bounds
  #   columns are identified by the respective suffix of the weight column,
  #   e.g. `stat_col_nms = c("s", "r")` and
  #   `weights = data.table(age_group = 1:4, weight_1 = 1:4, weight2 = 4:1)`
  #   will result in output columns `s_1`, `s2`, `r_1`, and `r2` etc.
  # @codedoc_comment_block directadjusting::directly_adjusted_estimates
  #' @return
  #' Returns a `data.table`. Returned columns are those given via
  #' `stratum_col_nms`, `stat_col_nms`, and `var_col_nms` and additional
  #' confidence interval columns. If `weights` was a
  #' `data.table`, the names of the stats, variances, and confidence bounds
  #' columns are identified by the respective suffix of the weight column,
  #' e.g. `stat_col_nms = c("s", "r")` and
  #' `weights = data.table(age_group = 1:4, weight_1 = 1:4, weight2 = 4:1)`
  #' will result in output columns `s_1`, `s2`, `r_1`, and `r2` etc.
  return(out[])
}

# @codedoc_comment_block news("directadjusting", "2024-12-10", "0.3.0")
# Remove deprecated `directadjusting::direct_adjusted_estimates`. Use
# `directadjusting::directly_adjusted_estimates`.
# @codedoc_comment_block news("directadjusting", "2024-12-10", "0.3.0")

#' @eval c(
#'   codedoc::codedoc_R_package_description("directadjusting"),
#'   codedoc::codedoc_news_for_R_package()
#' )
#' @keywords internal
"_PACKAGE"

# @codedoc_comment_block R_package_description(directadjusting)
# ${desc::desc_get_field("Description")}
#
# <!-- badges: start -->
# [![R-CMD-check](https://github.com/FinnishCancerRegistry/directadjusting/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/FinnishCancerRegistry/directadjusting/actions/workflows/R-CMD-check.yaml)
# <!-- badges: end -->
#
# # Recommended installation
#
# You can install this R package from CRAN.
#
# ```r
# install.packages("directadjusting")
# ```
#
# Alternatively this installs the latest release.
#
# ```r
# devtools::install_github(
#   "FinnishCancerRegistry/directadjusting@release"
# )
# ```
#
# # Example
# ```r
# # suppose we have poisson rates that we want to adjust for by age group.
# # they are stratified by sex.
# set.seed(1337)
# offsets <- rnorm(8, mean = 1000, sd = 100)
# baseline <- 100
# sex_hrs <- rep(1:2, each = 4)
# age_group_hrs <- rep(c(0.75, 0.90, 1.10, 1.25), times = 2)
# counts <- rpois(8, baseline * sex_hrs * age_group_hrs)
#
# # raw estimates
# my_stats <- data.table::data.table(
#   sex = rep(1:2, each = 4),
#   ag = rep(1:4, times = 2),
#   e = counts / offsets
# )
# my_stats[, "v" := my_stats[["e"]] / offsets]
# print(my_stats)
# #      sex    ag          e            v
# #    <int> <int>      <num>        <num>
# # 1:     1     1 0.08928141 8.759527e-05
# # 2:     1     2 0.10054601 1.175523e-04
# # 3:     1     3 0.11987410 1.238776e-04
# # 4:     1     4 0.09722692 8.365551e-05
# # 5:     2     1 0.18043221 1.937844e-04
# # 6:     2     2 0.14781448 1.227479e-04
# # 7:     2     3 0.21747515 1.987203e-04
# # 8:     2     4 0.21519746 1.781152e-04
#
# # adjusted by age group
# my_adj_stats <- directadjusting::directly_adjusted_estimates(
#   stats_dt = my_stats,
#   stat_col_nms = "e",
#   var_col_nms = "v",
#   conf_lvls = 0.95,
#   conf_methods = "log",
#   stratum_col_nms = "sex",
#   adjust_col_nms = "ag",
#   weights = c(200, 300, 400, 100)
# )
#
# print(my_adj_stats)
# # Key: <sex>
# #      sex         e            v       e_lo      e_hi
# #    <int>     <num>        <num>      <num>     <num>
# # 1:     1 0.1056924 3.474049e-05 0.09474912 0.1178996
# # 2:     2 0.1889406 5.237509e-05 0.17527556 0.2036710
# ```
# @codedoc_comment_block R_package_description(directadjusting)

# @codedoc_comment_block news("directadjusting", "2026-01-27", "0.6.0")
# First CRAN release.
# @codedoc_comment_block news("directadjusting", "2026-01-27", "0.6.0")
# @codedoc_comment_block news("directadjusting", "2026-02-02", "0.6.1")
# DESCRIPTION and documentation fixes.
# @codedoc_comment_block news("directadjusting", "2026-02-02", "0.6.1")

tmp_nms <- function(
  prefixes = "tmp_nm_",
  suffixes = "",
  avoid = "",
  pool = letters,
  n_random_elems = 10L,
  n_max_tries = 100L
) {
  df <- data.frame(
    prefix = prefixes,
    suffx = suffixes,
    tmp_nm = "",
    stringsAsFactors = FALSE
  )
  n_nms <- nrow(df)
  avoid <- c(avoid, "")
  for (i in seq(n_nms)) {
    while (df[["tmp_nm"]][i] %in% avoid) {
      random_part <- sample(pool, size = n_random_elems, replace = TRUE)
      random_part <- paste0(random_part, collapse = "")
      df[["tmp_nm"]][i] <- paste0(
        df[["prefix"]][i],
        random_part,
        df[["suffix"]][i]
      )
    }
    avoid <- c(avoid, df[["tpm_nm"]][i])
  }
  df[["tmp_nm"]]
}

confidence_interval_eval__ <- function(
  conf_method,
  theta,
  theta_variance,
  conf_lvl = 0.95
) {
  stopifnot(
    inherits(conf_method, c("character", "list", "call"))
  )
  if (is.character(conf_method)) {
    # @codedoc_comment_block directadjusting:::confidence_interval_eval__
    #   + If `conf_method` is a string, a pre-defined set of mathematical
    #     expressions are used to compute the confidence intervals.
    # @codedoc_comment_block directadjusting:::confidence_interval_eval__
    delta_method_confidence_interval_analytical__(
      transform = conf_method,
      theta = theta,
      theta_variance = theta_variance,
      conf_level = conf_lvl
    )
  } else if (is.call(conf_method)) {
    # @codedoc_comment_block directadjusting:::confidence_interval_eval__
    #   + If `conf_method` is a `call`, it is evaluated with the variables
    #     `theta`, `theta_variance`, `theta_standard_error`, and `z`. This is
    #     done once for the lower and once for the upper bound of the confidence
    #     interval, so for the lower bound and `conf_level = 0.95`
    #     we use `z = stats::qnorm(p = (1 - conf_lvl) / 2)`.
    # @codedoc_comment_block directadjusting:::confidence_interval_eval__
    data <- list(
      theta = theta,
      theta_variance = theta_variance,
      theta_standard_error = sqrt(theta_variance)
    )
    a <- (1 - conf_lvl)
    data[["z"]] <- stats::qnorm(p = a / 2)
    ci_lo <- eval(conf_method, data)
    data[["z"]] <- stats::qnorm(p = 1 - a / 2)
    ci_hi <- eval(conf_method, data)
    return(data.table::setDT(list(ci_lo = ci_lo, ci_hi = ci_hi))[])
  } else {
    # @codedoc_comment_block directadjusting:::confidence_interval_eval__
    #   + If `conf_method` is a `list`, it must contain elements `g` and
    #     `g_inv`, e.g. `list(g = quote(log(theta)), g_inv = quote(exp(g)))`.
    # @codedoc_insert_comment_block directadjusting:::delta_method_confidence_interval_algorithmic__
    # @codedoc_comment_block directadjusting:::confidence_interval_eval__
    delta_method_confidence_interval_algorithmic__(
      g = conf_method[["g"]],
      g_inv = conf_method[["g_inv"]],
      theta = theta,
      theta_variance = theta_variance,
      conf_level = conf_lvl
    )
  }
}

#' @title Confidence Intervals
#' @description
#' Functions to compute confidence intervals.
#' @name confidence_intervals
NULL

#' @eval codedoc::pkg_doc_fun(
#'   regex = "directadjusting::delta_method_confidence_intervals",
#'   rdname = "confidence_intervals"
#' )
#' @examples
#'
#' # directadjusting::delta_method_confidence_intervals
#' dt_1 <- directadjusting::delta_method_confidence_intervals(
#'   statistics = 0.9,
#'   variances = 0.1,
#'   conf_lvl = 0.95,
#'   conf_method = "log"
#' )
#'
#' # you can also supply your own math for computing the confidence intervals
#' dt_2 <- directadjusting::delta_method_confidence_intervals(
#'   statistics = 0.9,
#'   variances = 0.1,
#'   conf_lvl = 0.95,
#'   conf_method = quote(theta * exp(z * theta_standard_error / theta))
#' )
#'
#' dt_3 <- directadjusting::delta_method_confidence_intervals(
#'   statistics = 0.9,
#'   variances = 0.1,
#'   conf_lvl = 0.95,
#'   conf_method = list(
#'     g = quote(log(theta)),
#'     g_inv = quote(exp(g))
#'   )
#' )
#'
#' dt_4 <- directadjusting::delta_method_confidence_intervals(
#'   statistics = 0.9,
#'   variances = 0.1,
#'   conf_lvl = 0.95,
#'   conf_method = list(
#'     g = quote(stats::qnorm(theta)),
#'     g_inv = quote(stats::pnorm(g))
#'   )
#' )
#' stopifnot(
#'   all.equal(dt_1, dt_2, check.attributes = FALSE),
#'   all.equal(dt_1, dt_3, check.attributes = FALSE)
#' )
delta_method_confidence_intervals <- function(
  statistics,
  variances,
  conf_lvl = 0.95,
  conf_method = "identity"
) {
  stopifnot(
    #' @param statistics `[numeric]` (no default)
    #'
    #' Statistics for which to calculate confidence intervals.
    is.numeric(statistics),
    #' @param variances `[numeric]` (no default)
    #'
    #' Variance estimates of `statistics` used to compute confidence intervals.
    is.numeric(variances),
    variances >= 0 | is.na(variances),
    length(statistics) == length(variances),

    #' @param conf_lvl `[numeric]` (default `0.95`)
    #'
    #' Confidence level of confidence intervals in `]0, 1[`.
    length(conf_lvl) == 1,
    is.double(conf_lvl),
    conf_lvl < 1.0,
    conf_lvl > 0.0,

    #' @param conf_method `[character, call, list]` (default `"identity"`)
    #'
    #' Delta method transformation to be applied.
    #'
    #' - `character`: Use one of the pre-defined transformations. Table of
    #'   options with the corresponding expressions:
    #'
    #'   `r knitr::kable(delta_method_analytical_expressions_table__())`
    #'
    #' - `call`: A quoted R expression which produces the lower / upper limit
    #'   when evaluated. E.g.
    #'   `quote(theta * exp(z * theta_standard_error / theta))`.
    #' - `list`: Contains both the transformation and its inverse.
    #'   E.g. `list(g = quote(log(theta)), g_inv = quote(exp(g)))`.
    inherits(conf_method, c("character", "list", "call"))
  )

  # @codedoc_comment_block news("directadjusting::direct_adjusted_estimates", "2026-01-23", "0.5.0")
  # `directadjusting::delta_method_confidence_intervals` made a lot more
  # flexible. It now accepts via `conf_method` a string, a call, and a list
  # of calls that produce the desired confidence intervals.
  # @codedoc_comment_block news("directadjusting::direct_adjusted_estimates", "2026-01-23", "0.5.0")
  # @codedoc_comment_block directadjusting::delta_method_confidence_intervals
  # `directadjusting::delta_method_confidence_intervals` can be used to
  # compute confidence intervals using the delta method. The following steps
  # are performed:
  #
  # - Compute confidence intervals based on `conf_method`, `statistics`,
  #   `variances`, and `conf_lvl`.
  # @codedoc_insert_comment_block directadjusting:::confidence_interval_eval__
  # @codedoc_comment_block directadjusting::delta_method_confidence_intervals
  dt <- confidence_interval_eval__(
    conf_method = conf_method,
    theta = statistics,
    theta_variance = variances,
    conf_lvl = conf_lvl
  )
  # @codedoc_comment_block directadjusting::delta_method_confidence_intervals
  # - Collect a `data.table` with the confidence intervals and with also
  #   the columns `statistics = statistics` and `variance = variances`.
  # @codedoc_comment_block directadjusting::delta_method_confidence_intervals
  dt <- cbind(
    statistic = statistics,
    variance = variances,
    dt
  )

  # @codedoc_comment_block directadjusting::delta_method_confidence_intervals
  # - Add attribute named `ci_meta` to the `data.table`.
  #   This attribute is a list which contains elements `conf_lvl` and
  #   `conf_method`.
  # @codedoc_comment_block directadjusting::delta_method_confidence_intervals
  meta_list <- mget(c("conf_lvl", "conf_method"))
  data.table::setattr(
    x = dt,
    name = "ci_meta",
    value = meta_list
  )
  # @codedoc_comment_block directadjusting::delta_method_confidence_intervals
  # - Return `data.table` with columns
  #   `c("statistic", "variance", "ci_lo", "ci_hi")`.
  # @codedoc_comment_block directadjusting::delta_method_confidence_intervals
  # @codedoc_comment_block return(directadjusting::delta_method_confidence_intervals)
  # Returns a `data.table` with columns
  # `c("statistic", "variance", "ci_lo", "ci_hi")`.
  # @codedoc_comment_block return(directadjusting::delta_method_confidence_intervals)
  return(dt[])
}

weights_arg_to_weights_dt <- function(
  weights,
  adjust_col_nms,
  stats_dt
) {
  UseMethod("weights_arg_to_weights_dt")
}

#' @export
weights_arg_to_weights_dt.numeric <- function(
  weights,
  adjust_col_nms,
  stats_dt
) {
  stopifnot(
    length(weights) == data.table::uniqueN(stats_dt[[adjust_col_nms]])
  )

  weights_dt <- data.table::data.table(
    adjust_col = sort(unique(stats_dt[[adjust_col_nms]])),
    weight = weights
  )
  data.table::setnames(weights_dt, "adjust_col", adjust_col_nms)

  weights_dt[]
}

assert_is_weights_dt <- function(
  weights_dt,
  adjust_col_nms,
  stats_dt
) {
  lapply(adjust_col_nms, function(col_nm) {
    miss_levels <- setdiff(stats_dt[[col_nm]], weights_dt[[col_nm]])
    if (length(miss_levels) > 0) {
      stop(
        "Levels in stats_dt$",
        col_nm,
        " not in weights_dt$",
        col_nm,
        ": ",
        deparse(miss_levels)
      )
    }
  })
  invisible(NULL)
}

#' @export
weights_arg_to_weights_dt.data.table <- function(
  weights,
  adjust_col_nms,
  stats_dt
) {
  assert_is_weights_dt(
    weights_dt = weights,
    adjust_col_nms = adjust_col_nms,
    stats_dt = stats_dt
  )
  weights
}

add_weight_columns__ <- function(
  stats_dt,
  stratum_col_nms,
  weights_dt,
  adjust_col_nms = setdiff(names(weights_dt), "weight")
) {
  weight_col_nms <- names(weights_dt)[grepl("^weight", names(weights_dt))]
  tmp_weight_col_nms <- tmp_nms(
    prefixes = paste0(weight_col_nms, "_"),
    avoid = union(names(stats_dt), names(weights_dt)),
  )
  tmp_weight_sum_col_nm <- tmp_nms(
    prefixes = "tmp_w_sum_",
    avoid = union(names(stats_dt), names(weights_dt)),
  )
  # @codedoc_comment_block directadjusting:::add_weight_columns__
  #   + Weights are merged into `stats_dt` in-place by making a left join
  #     of `stats_dt` and `weights_dt`.
  # @codedoc_comment_block directadjusting:::add_weight_columns__
  data.table::set(
    x = stats_dt,
    j = tmp_weight_col_nms,
    value = weights_dt[
      i = stats_dt,
      on = adjust_col_nms,
      #' @importFrom data.table .SD
      j = .SD,
      .SDcols = weight_col_nms
    ]
  )
  # @codedoc_comment_block directadjusting:::add_weight_columns__
  #   + Re-scale weights to sum to one within each stratum defined by
  #     `stratum_col_nms`.
  # @codedoc_comment_block directadjusting:::add_weight_columns__
  lapply(tmp_weight_col_nms, function(tmp_weight_col_nm) {
    stats_dt[
      #' @importFrom data.table .SD :=
      j = (tmp_weight_sum_col_nm) := lapply(.SD, sum),
      .SDcols = tmp_weight_col_nm,
      by = eval(stratum_col_nms)
    ]
    data.table::set(
      stats_dt,
      j = tmp_weight_col_nm,
      value = stats_dt[[tmp_weight_col_nm]] / stats_dt[[tmp_weight_sum_col_nm]]
    )
  })
  data.table::set(stats_dt, j = tmp_weight_sum_col_nm, value = NULL)
  names(tmp_weight_col_nms) <- sub("weight", "", weight_col_nms)
  data.table::setattr(stats_dt, "tmp_weight_col_nms", tmp_weight_col_nms)
  invisible(stats_dt)
}

delta_method_variance_algorithmic__ <- function(
  g,
  theta,
  theta_variance
) {
  stopifnot(
    is.language(g),
    identical("theta", all.vars(g, functions = FALSE, unique = TRUE)),
    is.numeric(theta),
    length(theta) == length(theta_variance),
    is.numeric(theta_variance)
  )
  # @codedoc_comment_block directadjusting:::delta_method_variance_algorithmic__
  #     * `g` is passed to `[stats::deriv]`. If that fails, a numerical
  #       derivative is computed.
  # @codedoc_comment_block directadjusting:::delta_method_variance_algorithmic__
  g_gradient_expr <- tryCatch(
    stats::deriv(expr = g, "theta"),
    error = function(e) e
  )
  if (inherits(g_gradient_expr, "error")) {
    g_gradient_value <- numerical_derivative__(
      expr = g,
      theta = theta
    )
  } else {
    g_gradient_value <- eval(g_gradient_expr, list(theta = theta))
    g_gradient_value <- as.numeric(attr(g_gradient_value, "gradient"))
  }
  # @codedoc_comment_block directadjusting:::delta_method_variance_algorithmic__
  #     * With the derivative known the variance after the transformation
  #       is `variance * g_gradient ^ 2`.
  # @codedoc_comment_block directadjusting:::delta_method_variance_algorithmic__
  return(theta_variance * (g_gradient_value^2))
}

delta_method_variance_analytical__ <- function(
  transform = "log",
  theta,
  theta_variance
) {
  stopifnot(
    is.numeric(theta),
    length(theta) == length(theta_variance),

    is.numeric(theta_variance),
    ifelse(
      is.na(theta_variance),
      TRUE,
      theta_variance >= 0
    )
  )
  g_gradient_expr <-
    delta_method_analytical_expressions__(
      transform
    )[["g_gradient"]]
  g_gradient_value <- eval(g_gradient_expr, list(theta = theta))
  out <- theta_variance * (g_gradient_value^2)
  out[theta_variance == 0.0] <- 0.0
  return(out)
}

delta_method_confidence_interval_eval__ <- function(
  g,
  g_inv,
  theta,
  g_variance,
  conf_level = 0.95
) {
  transform_value <- eval(g, list(theta = theta))
  a <- (1 - conf_level)
  # @codedoc_comment_block directadjusting:::delta_method_confidence_interval_eval__
  #     * With the transformed variance known the transform confidence interval
  #       is calculated simply via `g(theta) + g_standard_error * z`.
  # @codedoc_comment_block directadjusting:::delta_method_confidence_interval_eval__
  transform_standard_error_value <- sqrt(g_variance)
  transform_ci_lo <- transform_value +
    stats::qnorm(p = a / 2) *
      transform_standard_error_value
  transform_ci_hi <- transform_value +
    stats::qnorm(p = 1 - a / 2) *
      transform_standard_error_value
  # @codedoc_comment_block directadjusting:::delta_method_confidence_interval_eval__
  #     * These transformation-scale confidence intervals are then converted
  #       back to the original scale using `g_inv`.
  # @codedoc_comment_block directadjusting:::delta_method_confidence_interval_eval__
  theta_ci_lo <- eval(g_inv, list(g = transform_ci_lo))
  theta_ci_hi <- eval(g_inv, list(g = transform_ci_hi))
  out <- data.table::setDT(list(ci_lo = theta_ci_lo, ci_hi = theta_ci_hi))
  out[
    i = out[["ci_lo"]] > out[["ci_hi"]],
    #' @importFrom data.table := .SD
    j = c("ci_lo", "ci_hi") := list(.SD[["ci_hi"]], .SD[["ci_lo"]])
  ]
  return(out[])
}

delta_method_confidence_interval_algorithmic__ <- function(
  g,
  g_inv,
  theta,
  theta_variance,
  conf_level = 0.95
) {
  stopifnot(
    is.call(g_inv),
    identical(all.vars(g_inv, functions = FALSE, unique = TRUE), "g"),
    all.equal(
      eval(g_inv, list(g = eval(g, list(theta = theta)))),
      theta
    )
  )
  # @codedoc_comment_block directadjusting:::delta_method_confidence_interval_algorithmic__
  # @codedoc_insert_comment_block directadjusting:::delta_method_variance_algorithmic__
  # @codedoc_comment_block directadjusting:::delta_method_confidence_interval_algorithmic__
  g_variance <- delta_method_variance_algorithmic__(
    g = g,
    theta = theta,
    theta_variance = theta_variance
  )
  # @codedoc_comment_block directadjusting:::delta_method_confidence_interval_algorithmic__
  # @codedoc_insert_comment_block directadjusting:::delta_method_confidence_interval_eval__
  # @codedoc_comment_block directadjusting:::delta_method_confidence_interval_algorithmic__
  out <- delta_method_confidence_interval_eval__(
    g = g,
    g_inv = g_inv,
    theta = theta,
    g_variance = g_variance,
    conf_level = conf_level
  )
  return(out[])
}

delta_method_analytical_expressions_list__ <- list(
  "identity" = list(
    g = quote(theta),
    g_inv = quote(g),
    g_gradient = quote(1)
  ),
  "log" = list(
    g = quote(log(theta)),
    g_inv = quote(exp(g)),
    g_gradient = quote(1 / theta)
  ),
  "log-log" = list(
    g = quote(log(-log(theta))),
    g_inv = quote(exp(-exp(g))),
    g_gradient = quote(1 / (theta * log(theta)))
  ),
  "logit" = list(
    g = quote(log(theta) - log(1 - theta)),
    g_inv = quote(1 / (1 + exp(-g))),
    g_gradient = quote(1 / (theta - theta^2))
  )
)

delta_method_analytical_expressions_table__ <- function() {
  dt <- data.table::data.table(
    name = names(delta_method_analytical_expressions_list__)
  )
  for (elem_nm in names(delta_method_analytical_expressions_list__[[1]])) {
    for (i in seq_len(nrow(dt))) {
      data.table::set(
        x = dt,
        i = i,
        j = elem_nm,
        value = deparse1(
          delta_method_analytical_expressions_list__[[i]][[elem_nm]]
        )
      )
    }
  }
  return(dt[])
}

allowed_conf_method_strings__ <- function() {
  c("none", names(delta_method_analytical_expressions_list__))
}

delta_method_analytical_expressions__ <- function(
  transform
) {
  stopifnot(
    is.character(transform),
    length(transform) == 1
  )
  if (!transform %in% names(delta_method_analytical_expressions_list__)) {
    stop("No such transformation pre-defined: ", transform)
  }
  return(delta_method_analytical_expressions_list__[[transform]])
}

numerical_derivative__ <- function(
  expr,
  theta,
  h = sqrt(.Machine$double.eps)
) {
  lo <- eval(expr, list(theta = theta - h))
  hi <- eval(expr, list(theta = theta + h))
  deriv <- (hi - lo) / (2 * h)
  return(deriv)
}

delta_method_confidence_interval_analytical__ <- function(
  transform,
  theta,
  theta_variance,
  conf_level = 0.95
) {
  g_variance <- delta_method_variance_analytical__(
    transform = transform,
    theta = theta,
    theta_variance = theta_variance
  )
  expressions <- delta_method_analytical_expressions__(
    transform = transform
  )
  out <- delta_method_confidence_interval_eval__(
    g = expressions[["g"]],
    g_inv = expressions[["g_inv"]],
    theta = theta,
    g_variance = g_variance,
    conf_level = conf_level
  )
  return(out[])
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/package_directadjusting.R
\docType{package}
\name{directadjusting-package}
\alias{directadjusting}
\alias{directadjusting-package}
\title{directadjusting: Directly Adjusted Estimates}
\description{
Compute estimates and confidence intervals of weighted averages quickly and easily. Weighted averages are computed using data.table for speed. Confidence intervals are approximated using the delta method with either using known formulae or via algorithmic or numerical derivation.

\href{https://github.com/FinnishCancerRegistry/directadjusting/actions/workflows/R-CMD-check.yaml}{\if{html}{\figure{https://github.com/FinnishCancerRegistry/directadjusting/actions/workflows/R-CMD-check.yaml/badge.svg}}}
}
\section{Recommended installation}{
You can install this R package from CRAN.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{install.packages("directadjusting")
}\if{html}{\out{</div>}}

Alternatively this installs the latest release.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{devtools::install_github(
  "FinnishCancerRegistry/directadjusting@release"
)
}\if{html}{\out{</div>}}
}

\section{Example}{
\if{html}{\out{<div class="sourceCode r">}}\preformatted{# suppose we have poisson rates that we want to adjust for by age group.
# they are stratified by sex.
set.seed(1337)
offsets <- rnorm(8, mean = 1000, sd = 100)
baseline <- 100
sex_hrs <- rep(1:2, each = 4)
age_group_hrs <- rep(c(0.75, 0.90, 1.10, 1.25), times = 2)
counts <- rpois(8, baseline * sex_hrs * age_group_hrs)

# raw estimates
my_stats <- data.table::data.table(
  sex = rep(1:2, each = 4),
  ag = rep(1:4, times = 2),
  e = counts / offsets
)
my_stats[, "v" := my_stats[["e"]] / offsets]
print(my_stats)
#      sex    ag          e            v
#    <int> <int>      <num>        <num>
# 1:     1     1 0.08928141 8.759527e-05
# 2:     1     2 0.10054601 1.175523e-04
# 3:     1     3 0.11987410 1.238776e-04
# 4:     1     4 0.09722692 8.365551e-05
# 5:     2     1 0.18043221 1.937844e-04
# 6:     2     2 0.14781448 1.227479e-04
# 7:     2     3 0.21747515 1.987203e-04
# 8:     2     4 0.21519746 1.781152e-04

# adjusted by age group
my_adj_stats <- directadjusting::directly_adjusted_estimates(
  stats_dt = my_stats,
  stat_col_nms = "e",
  var_col_nms = "v",
  conf_lvls = 0.95,
  conf_methods = "log",
  stratum_col_nms = "sex",
  adjust_col_nms = "ag",
  weights = c(200, 300, 400, 100)
)

print(my_adj_stats)
# Key: <sex>
#      sex         e            v       e_lo      e_hi
#    <int>     <num>        <num>      <num>     <num>
# 1:     1 0.1056924 3.474049e-05 0.09474912 0.1178996
# 2:     2 0.1889406 5.237509e-05 0.17527556 0.2036710
}\if{html}{\out{</div>}}
}

\section{News}{

\subsection{News for version 0.7.0}{
\subsection{directadjusting::directly_adjusted_estimates}{

\code{directadjusting::directly_adjusted_estimates} argument \code{adjust_col_nms} is
now automatically
determined based on \code{weights} if \code{weights} is a \code{data.frame} /
\code{data.table}.
}

\subsection{directadjusting::directly_adjusted_estimates}{

\code{directadjusting::directly_adjusted_estimates} can now handle \code{weights}
\code{data.table} with more than one column containing weights, e.g.
\code{weight_europe}, \code{weight_world}.
}

}

\subsection{News for version 0.6.1}{
\subsection{directadjusting}{

DESCRIPTION and documentation fixes.
}

}

\subsection{News for version 0.6.0}{
\subsection{directadjusting}{

First CRAN release.
}

}

\subsection{News for version 0.5.0}{
\subsection{directadjusting::direct_adjusted_estimates}{

\code{directadjusting::delta_method_confidence_intervals} made a lot more
flexible. It now accepts via \code{conf_method} a string, a call, and a list
of calls that produce the desired confidence intervals.
}

\subsection{directadjusting::direct_adjusted_estimates}{

\code{directadjusting::direct_adjusted_estimates} option \code{conf_methods = "boot"}
removed. Only delta method confidence intervals now possible. Making use of
the delta method is now more flexible and accepts e.g.
\code{list("log", list(g = quote(qnorm(theta)), g_inv = quote(pnorm(g))))}.
}

\subsection{directadjusting::direct_adjusted_estimates}{

\code{directadjusting::direct_adjusted_estimates} now allows for the sake of
convenience to be called with no \code{adjust_col_nms} defined. This results
in no adjusting.
}

}

\subsection{News for version 0.4.0}{
\subsection{directadjusting::direct_adjusted_estimates}{

\code{directadjusting::direct_adjusted_estimates} now correctly uses
the same \code{conf_lvls} and \code{conf_methods} for all statistics when their
length is one.
}

}

\subsection{News for version 0.3.0}{
\subsection{directadjusting}{

Remove deprecated \code{directadjusting::direct_adjusted_estimates}. Use
\code{directadjusting::directly_adjusted_estimates}.
}

}
}

\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/FinnishCancerRegistry/directadjusting}
  \item Report bugs at \url{https://github.com/FinnishCancerRegistry/directadjusting/issues}
}

}
\author{
\strong{Maintainer}: Joonas Miettinen \email{joonas.miettinen@cancer.fi} (\href{https://orcid.org/0000-0001-8624-6754}{ORCID})

Authors:
\itemize{
  \item Joonas Miettinen \email{joonas.miettinen@cancer.fi} (\href{https://orcid.org/0000-0001-8624-6754}{ORCID})
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/confidence_intervals.R
\name{confidence_intervals}
\alias{confidence_intervals}
\alias{delta_method_confidence_intervals}
\title{Confidence Intervals}
\usage{
delta_method_confidence_intervals(
  statistics,
  variances,
  conf_lvl = 0.95,
  conf_method = "identity"
)
}
\arguments{
\item{statistics}{\verb{[numeric]} (no default)

Statistics for which to calculate confidence intervals.}

\item{variances}{\verb{[numeric]} (no default)

Variance estimates of \code{statistics} used to compute confidence intervals.}

\item{conf_lvl}{\verb{[numeric]} (default \code{0.95})

Confidence level of confidence intervals in \verb{]0, 1[}.}

\item{conf_method}{\verb{[character, call, list]} (default \code{"identity"})

Delta method transformation to be applied.
\itemize{
\item \code{character}: Use one of the pre-defined transformations. Table of
options with the corresponding expressions:
}\tabular{llll}{
   name \tab g \tab g_inv \tab g_gradient \cr
   identity \tab theta \tab g \tab 1 \cr
   log \tab log(theta) \tab exp(g) \tab 1/theta \cr
   log-log \tab log(-log(theta)) \tab exp(-exp(g)) \tab 1/(theta * log(theta)) \cr
   logit \tab log(theta) - log(1 - theta) \tab 1/(1 + exp(-g)) \tab 1/(theta - theta^2) \cr
}

\itemize{
\item \code{call}: A quoted R expression which produces the lower / upper limit
when evaluated. E.g.
\code{quote(theta * exp(z * theta_standard_error / theta))}.
\item \code{list}: Contains both the transformation and its inverse.
E.g. \code{list(g = quote(log(theta)), g_inv = quote(exp(g)))}.
}}
}
\value{
\strong{directadjusting::delta_method_confidence_intervals}

Returns a \code{data.table} with columns
\code{c("statistic", "variance", "ci_lo", "ci_hi")}.
}
\description{
Functions to compute confidence intervals.
}
\section{Functions}{

\strong{directadjusting::delta_method_confidence_intervals}

\code{directadjusting::delta_method_confidence_intervals} can be used to
compute confidence intervals using the delta method. The following steps
are performed:
\itemize{
\item Compute confidence intervals based on \code{conf_method}, \code{statistics},
\code{variances}, and \code{conf_lvl}.
\itemize{
\item If \code{conf_method} is a string, a pre-defined set of mathematical
expressions are used to compute the confidence intervals.
\item If \code{conf_method} is a \code{call}, it is evaluated with the variables
\code{theta}, \code{theta_variance}, \code{theta_standard_error}, and \code{z}. This is
done once for the lower and once for the upper bound of the confidence
interval, so for the lower bound and \code{conf_level = 0.95}
we use \code{z = stats::qnorm(p = (1 - conf_lvl) / 2)}.
\item If \code{conf_method} is a \code{list}, it must contain elements \code{g} and
\code{g_inv}, e.g. \code{list(g = quote(log(theta)), g_inv = quote(exp(g)))}.
\itemize{
\item \code{g} is passed to \verb{[stats::deriv]}. If that fails, a numerical
derivative is computed.
\item With the derivative known the variance after the transformation
is \code{variance * g_gradient ^ 2}.
\item With the transformed variance known the transform confidence interval
is calculated simply via \code{g(theta) + g_standard_error * z}.
\item These transformation-scale confidence intervals are then converted
back to the original scale using \code{g_inv}.
}
}
\item Collect a \code{data.table} with the confidence intervals and with also
the columns \code{statistics = statistics} and \code{variance = variances}.
\item Add attribute named \code{ci_meta} to the \code{data.table}.
This attribute is a list which contains elements \code{conf_lvl} and
\code{conf_method}.
\item Return \code{data.table} with columns
\code{c("statistic", "variance", "ci_lo", "ci_hi")}.
}
}

\examples{

# directadjusting::delta_method_confidence_intervals
dt_1 <- directadjusting::delta_method_confidence_intervals(
  statistics = 0.9,
  variances = 0.1,
  conf_lvl = 0.95,
  conf_method = "log"
)

# you can also supply your own math for computing the confidence intervals
dt_2 <- directadjusting::delta_method_confidence_intervals(
  statistics = 0.9,
  variances = 0.1,
  conf_lvl = 0.95,
  conf_method = quote(theta * exp(z * theta_standard_error / theta))
)

dt_3 <- directadjusting::delta_method_confidence_intervals(
  statistics = 0.9,
  variances = 0.1,
  conf_lvl = 0.95,
  conf_method = list(
    g = quote(log(theta)),
    g_inv = quote(exp(g))
  )
)

dt_4 <- directadjusting::delta_method_confidence_intervals(
  statistics = 0.9,
  variances = 0.1,
  conf_lvl = 0.95,
  conf_method = list(
    g = quote(stats::qnorm(theta)),
    g_inv = quote(stats::pnorm(g))
  )
)
stopifnot(
  all.equal(dt_1, dt_2, check.attributes = FALSE),
  all.equal(dt_1, dt_3, check.attributes = FALSE)
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/direct_adjusting.R
\name{directly_adjusted_estimates}
\alias{directly_adjusted_estimates}
\title{Directly Adjusted Estimates}
\usage{
directly_adjusted_estimates(
  stats_dt,
  stat_col_nms,
  var_col_nms,
  stratum_col_nms = NULL,
  adjust_col_nms = NULL,
  conf_lvls = 0.95,
  conf_methods = "identity",
  weights = NULL
)
}
\arguments{
\item{stats_dt}{\verb{[data.frame]} (no default)

a \code{data.frame} containing estimates and variance estimates of statistics}

\item{stat_col_nms}{\verb{[character]} (no default)

names of columns in \code{stats_dt} containing estimates (statistics);
\code{NA} statistics values cause also \code{NA} confidence intervals}

\item{var_col_nms}{\verb{[character]} (default \code{NULL})
\itemize{
\item if \code{NULL}, no confidence intervals can (will) be computed
\item if \code{character} vector, names of columns in \code{stats_dt} containing variance
estimates of the statistics specified in \code{stat_col_nms} with one-to-one
correspondence; \code{NA} elements in \code{var_col_nms} cause no confidence
intervals to computed for those statistics;
\code{NA} variance estimates in \code{stats_dt} cause \code{NA} confidence intervals;
negative values cause an error; \code{Inf} values cause \code{c(-Inf, Inf)}
intervals with confidence interval method \code{"identity"}, etc.
}}

\item{stratum_col_nms}{\verb{[NULL, character]} (default \code{NULL})

names of columns in \code{stats_dt} by which statistics are stratified (and they
should be stratified by these columns after direct adjusting)}

\item{adjust_col_nms}{\verb{[NULL, character]} (default \code{NULL})

Names of columns in \code{stats_dt} by which statistics are currently stratified
and by which the statistics should be adjusted (e.g. \code{"agegroup"}).
\itemize{
\item \code{NULL}: If \code{weights} is a \code{data.table}, use its stratifying columns. Else
no adjusting is performed.
\item \code{character}: Adjust by these columns.
}}

\item{conf_lvls}{\verb{[numeric]} (default \code{0.95})

confidence levels for confidence intervals; you may specify each statistic
(see \code{stat_col_nms}) its own level by supplying a vector of values;
values other than between \verb{(0, 1)} cause an error}

\item{conf_methods}{\verb{[character, list]} (default \code{"identity"})

Method(s) to compute confidence intervals. Either one method for all stats
(\code{stat_col_nms}) or otherwise this must be of length
(\code{length(stat_col_nms)}). Each element is passed to
\verb{[delta_method_confidence_intervals]} separately.

Can also be \code{"none"}: This causes no confidence intervals to be calculated
for the respective \code{stat_col_nms} element(s).}

\item{weights}{\verb{[double, data.table, character]}

The weights need not sum to one as this is ensured internally. You may
supply weights in one of the following ways:
\itemize{
\item \code{double}: A vector of weights, the length of which must match the number
of strata defined by adjusting variables.
\item \code{data.table}: With one or more columns with names matching to those
variables that are used to adjust estimates, and one column named
\code{weight}. E.g. \code{data.table(agegroup = 1:3, weight = c(100, 500, 400))}.
}}
}
\value{
Returns a \code{data.table}. Returned columns are those given via
\code{stratum_col_nms}, \code{stat_col_nms}, and \code{var_col_nms} and additional
confidence interval columns. If \code{weights} was a
\code{data.table}, the names of the stats, variances, and confidence bounds
columns are identified by the respective suffix of the weight column,
e.g. \code{stat_col_nms = c("s", "r")} and
\code{weights = data.table(age_group = 1:4, weight_1 = 1:4, weight2 = 4:1)}
will result in output columns \code{s_1}, \code{s2}, \code{r_1}, and \code{r2} etc.
}
\description{
Compute direct adjusted estimates from a table of statistics.
}
\details{
\code{directadjusting::directly_adjusted_estimates} computes weighted
averages and their confidence intervals. Performs the following steps:
\itemize{
\item Makes a new \code{data.table} with data from \code{stats_dt} without copying any
column data to avoid modifying \code{stats_dt} itself.
\item Handle argument \code{weights} in order to produce a \code{data.table} of weights
if it wasn't one already.
\item Insert the weights into \code{stats_dt}.
\itemize{
\item Weights are merged into \code{stats_dt} in-place by making a left join
of \code{stats_dt} and \code{weights_dt}.
\item Re-scale weights to sum to one within each stratum defined by
\code{stratum_col_nms}.
}
\item Compute weighted averages of \code{stat_col_nms} and \code{var_col_nms}
(the latter with squared weights because they are variances)
over \code{adjust_col_nms}. This results in a \code{data.table} without column(s)
\code{adjust_col_nms}.
\item For each statistic:
\itemize{
\item If the corresponding \code{conf_methods} element is \code{"none"}, skip confidence
intervals computation.
\item Otherwise call \verb{[delta_method_confidence_intervals]}.
}
\item Set attribute \code{directly_adjusted_estimates_meta}. It is a list
containing:
\itemize{
\item \code{call}: The call to \code{directadjusting::directly_adjusted_estimates}.
\item \code{stat_col_nms}: The argument as given by the user.
\item \code{var_col_nms}: The argument as given by the user.
\item \code{stratum_col_nms}: The argument as given by the user.
\item \code{adjust_col_nms}: The argument as given by the user.
\item \code{conf_lvls}: The argument, but always of length \code{length(stat_col_nms)}.
\item \code{conf_methods}: The argument, but always of length
\code{length(stat_col_nms)}.
\item \code{meta_dt}: Contains columns
\itemize{
\item \code{stat_col_nm}: Elements of argument \code{stat_col_nms}.
\item \code{stat_col_nm_w}: Corresponding name of column containing weighted
statistics. These columns names are in the output of
\code{directadjusting::directly_adjusted_estimates}.
\item \code{var_col_nm}: Elements of argument \code{var_col_nms}.
\item \code{var_col_nm_w}: Like \code{stat_col_nm_w} but for variance column names.
\item \code{conf_method}: Correspoding \code{conf_methods} elements.
\item \code{conf_lvl}: Correspoding \code{conf_lvls} elements.
\item \code{ci_lo_col_nm_w}: Name of confidence interval lower bound of the
weighted statistic.
\item \code{ci_hi_col_nm_w}: Name of confidence interval upper bound of the
weighted statistic.
}
}
\item Return a \code{data.table}. Returned columns are those given via
\code{stratum_col_nms}, \code{stat_col_nms}, and \code{var_col_nms} and additional
confidence interval columns. If \code{weights} was a
\code{data.table}, the names of the stats, variances, and confidence bounds
columns are identified by the respective suffix of the weight column,
e.g. \code{stat_col_nms = c("s", "r")} and
\code{weights = data.table(age_group = 1:4, weight_1 = 1:4, weight2 = 4:1)}
will result in output columns \code{s_1}, \code{s2}, \code{r_1}, and \code{r2} etc.
}
}
\section{News for version 0.7.0}{


\code{directadjusting::directly_adjusted_estimates} argument \code{adjust_col_nms} is
now automatically
determined based on \code{weights} if \code{weights} is a \code{data.frame} /
\code{data.table}.

\code{directadjusting::directly_adjusted_estimates} can now handle \code{weights}
\code{data.table} with more than one column containing weights, e.g.
\code{weight_europe}, \code{weight_world}.
}

\examples{

# directadjusting::directly_adjusted_estimates
library("data.table")
set.seed(1337)

offsets <- rnorm(8, mean = 1000, sd = 100)
baseline <- 100
hrs_by_sex <- rep(1:2, each = 4)
hrs_by_ag <- rep(c(0.75, 0.90, 1.10, 1.25), times = 2)
counts <- rpois(8, baseline * hrs_by_sex * hrs_by_ag)

# raw estimates
my_stats <- data.table::data.table(
  sex = rep(1:2, each = 4),
  ag = rep(1:4, times = 2),
  e = counts / offsets,
  v = counts / (offsets**2)
)

# adjusted by age group
my_adj_stats <- directly_adjusted_estimates(
  stats_dt = my_stats,
  stat_col_nms = "e",
  var_col_nms = "v",
  conf_lvls = 0.95,
  conf_methods = "log",
  stratum_col_nms = "sex",
  adjust_col_nms = "ag",
  weights = c(200, 300, 400, 100)
)

# adjusted by smaller age groups, stratified by larger age groups
my_stats[, "ag2" := c(1, 1, 2, 2, 1, 1, 2, 2)]
my_adj_stats <- directly_adjusted_estimates(
  stats_dt = my_stats,
  stat_col_nms = "e",
  var_col_nms = "v",
  conf_lvls = 0.95,
  conf_methods = "log",
  stratum_col_nms = c("sex", "ag2"),
  adjust_col_nms = "ag",
  weights = c(200, 300, 400, 100)
)

# with no adjusting columns defined you get the same table as input
# but with confidence intervals. this for the sake of
# convenience for programming cases where sometimes you want to adjust,
# sometimes not.
stats_dt_2 <- data.table::data.table(
  sex = 0:1,
  e = 0.0,
  v = 0.1
)
dt_2 <- directadjusting::directly_adjusted_estimates(
  stats_dt = stats_dt_2,
  stat_col_nms = "e",
  var_col_nms = "v",
  conf_lvls = 0.95,
  conf_methods = "identity",
  stratum_col_nms = "sex"
)
stopifnot(
  dt_2[["e"]] == stats_dt_2[["e"]],
  dt_2[["v"]] == stats_dt_2[["v"]],
  dt_2[["sex"]] == stats_dt_2[["sex"]]
)

# sometimes when adjusting rates or counts, there can be strata where the
# statistic is zero. these should be included in your statistics dataset
# if you still want the weighted average be influenced by the zero.
# otherwise you will get the wrong result. sometimes when naively tabulating
# a dataset with e.g. dt[, .N, keyby = "stratum"] one does not get a result
# row for a stratum that does not appear in the dataset even if we know that
# the stratum exists, for instance only the age groups 1-17 are present in
# the dataset.
stats_dt_3 <- data.table::data.table(
  age_group = 1:18,
  count = 17:0,
  var = 17:0
)

# this goes as intended
dt_3 <- directadjusting::directly_adjusted_estimates(
  stats_dt = stats_dt_3,
  stat_col_nms = "count",
  var_col_nms = "var",
  stratum_col_nms = NULL,
  adjust_col_nms = "age_group",
  weights = data.table::data.table(
    age_group = 1:18,
    weight = 18:1
  )
)

# this does not
dt_4 <- directadjusting::directly_adjusted_estimates(
  stats_dt = stats_dt_3[1:17, ],
  stat_col_nms = "count",
  var_col_nms = "var",
  stratum_col_nms = NULL,
  adjust_col_nms = "age_group",
  weights = data.table::data.table(
    age_group = 1:18,
    weight = 18:1
  )
)

# the weighted average that included the zero is smaller
stopifnot(
  dt_3[["count"]] < dt_4[["count"]]
)

# NAs are allowed and produce in turn NAs silently.
stats_dt_5 <- data.table::data.table(
  age_group = 1:18,
  count = c(NA, 16:0),
  var = c(NA, 16:0)
)
dt_5 <- directadjusting::directly_adjusted_estimates(
  stats_dt = stats_dt_5,
  stat_col_nms = "count",
  var_col_nms = "var",
  adjust_col_nms = "age_group",
  weights = data.table::data.table(
    age_group = 1:18,
    weight = 18:1
  )
)
stopifnot(
  is.na(dt_5)
)

stats_dt_6 <- data.table::data.table(
  age_group = 1:4,
  survival = c(0.20, 0.40, 0.60, 0.80),
  survival_var = 0.05^2
)
# you can use conf_methods to pass whatever to
# `delta_method_confidence_intervals`.
dt_6 <- directadjusting::directly_adjusted_estimates(
  stats_dt = stats_dt_6,
  stat_col_nms = "survival",
  var_col_nms = "survival_var",
  adjust_col_nms = "age_group",
  weights = data.table::data.table(
    age_group = 1:4,
    weight = 1:4
  ),
  conf_methods = list(
    list(
      g = quote(stats::qnorm(theta)),
      g_inv = quote(stats::pnorm(g))
    )
  )
)

# the wame weights data.table can contain more than one weight column
dt_7 <- directadjusting::directly_adjusted_estimates(
  stats_dt = stats_dt_6,
  stat_col_nms = "survival",
  var_col_nms = "survival_var",
  adjust_col_nms = "age_group",
  weights = data.table::data.table(
    age_group = 1:4,
    weight_1 = 1:4,
    weight2 = 4:1
  )
)
stopifnot(
  c("survival_1", "survival2") \%in\% names(dt_7)
)

# ... and multiple statistics columns as well
data.table::set(
  x = stats_dt_6,
  j = c("risk", "risk_var"),
  value = list(
    1 - stats_dt_6[["survival"]],
    stats_dt_6[["survival_var"]]
  )
)
dt_8 <- directadjusting::directly_adjusted_estimates(
  stats_dt = stats_dt_6,
  stat_col_nms = c("survival", "risk"),
  var_col_nms = c("survival_var", "risk_var"),
  adjust_col_nms = "age_group",
  weights = data.table::data.table(
    age_group = 1:4,
    weight_1 = 1:4,
    weight2 = 4:1
  )
)
stopifnot(
  c("survival_1", "survival2", "risk_1", "risk2") \%in\% names(dt_8)
)

}
